ActiveResource::Base is the main class for mapping RESTful resources as models in a Rails application.
For an outline of what Active Resource is capable of, see files/vendor/rails/activeresource/README.html.
Automated mapping
Active Resource objects represent your RESTful resources as manipulatable Ruby objects. To map resources to Ruby objects, Active Resource only needs a class name that corresponds to the resource name (e.g., the class Person maps to the resources people, very similarly to Active Record) and a site value, which holds the URI of the resources.
class Person < ActiveResource::Base
self.site = "http://api.people.com:3000/"
end
Now the Person class is mapped to RESTful resources located at api.people.com:3000/people/, and you can now use Active Resource‘s lifecycles methods to manipulate resources. In the case where you already have an existing model with the same name as the desired RESTful resource you can set the element_name value.
class PersonResource < ActiveResource::Base
self.site = "http://api.people.com:3000/"
self.element_name = "person"
end
Lifecycle methods
Active Resource exposes methods for creating, finding, updating, and deleting resources from REST web services.
ryan = Person.new(:first => 'Ryan', :last => 'Daigle') ryan.save # => true ryan.id # => 2 Person.exists?(ryan.id) # => true ryan.exists? # => true ryan = Person.find(1) # Resource holding our newly created Person object ryan.first = 'Rizzle' ryan.save # => true ryan.destroy # => true
As you can see, these are very similar to Active Record‘s lifecycle methods for database records. You can read more about each of these methods in their respective documentation.
Custom REST methods
Since simple CRUD/lifecycle methods can‘t accomplish every task, Active Resource also supports defining your own custom REST methods. To invoke them, Active Resource provides the get, post, put and \delete methods where you can specify a custom REST method name to invoke.
# POST to the custom 'register' REST method, i.e. POST /people/new/register.xml.
Person.new(:name => 'Ryan').post(:register)
# => { :id => 1, :name => 'Ryan', :position => 'Clerk' }
# PUT an update by invoking the 'promote' REST method, i.e. PUT /people/1/promote.xml?position=Manager.
Person.find(1).put(:promote, :position => 'Manager')
# => { :id => 1, :name => 'Ryan', :position => 'Manager' }
# GET all the positions available, i.e. GET /people/positions.xml.
Person.get(:positions)
# => [{:name => 'Manager'}, {:name => 'Clerk'}]
# DELETE to 'fire' a person, i.e. DELETE /people/1/fire.xml.
Person.find(1).delete(:fire)
For more information on using custom REST methods, see the ActiveResource::CustomMethods documentation.
Validations
You can validate resources client side by overriding validation methods in the base class.
class Person < ActiveResource::Base
self.site = "http://api.people.com:3000/"
protected
def validate
errors.add("last", "has invalid characters") unless last =~ /[a-zA-Z]*/
end
end
See the ActiveResource::Validations documentation for more information.
Authentication
Many REST APIs will require authentication, usually in the form of basic HTTP authentication. Authentication can be specified by:
HTTP Basic Authentication
- putting the credentials in the URL for the site variable.
class Person < ActiveResource::Base self.site = "http://ryan:password@api.people.com:3000/" end
- defining user and/or password variables
class Person < ActiveResource::Base self.site = "http://api.people.com:3000/" self.user = "ryan" self.password = "password" end
For obvious security reasons, it is probably best if such services are available over HTTPS.
Note: Some values cannot be provided in the URL passed to site. e.g. email addresses as usernames. In those situations you should use the separate user and password option.
Certificate Authentication
- End point uses an X509 certificate for authentication. See ssl_options= for all options.
class Person < ActiveResource::Base self.site = "https://secure.api.people.com/" self.ssl_options = {:cert => OpenSSL::X509::Certificate.new(File.open(pem_file)) :key => OpenSSL::PKey::RSA.new(File.open(pem_file)), :ca_path => "/path/to/OpenSSL/formatted/CA_Certs", :verify_mode => OpenSSL::SSL::VERIFY_PEER} end
Errors & Validation
Error handling and validation is handled in much the same manner as you‘re used to seeing in Active Record. Both the response code in the HTTP response and the body of the response are used to indicate that an error occurred.
Resource errors
When a GET is requested for a resource that does not exist, the HTTP 404 (Resource Not Found) response code will be returned from the server which will raise an ActiveResource::ResourceNotFound exception.
# GET http://api.people.com:3000/people/999.xml ryan = Person.find(999) # 404, raises ActiveResource::ResourceNotFound
404 is just one of the HTTP error response codes that Active Resource will handle with its own exception. The following HTTP response codes will also result in these exceptions:
- 200..399 - Valid response, no exception (other than 301, 302)
- 301, 302 - ActiveResource::Redirection
- 400 - ActiveResource::BadRequest
- 401 - ActiveResource::UnauthorizedAccess
- 403 - ActiveResource::ForbiddenAccess
- 404 - ActiveResource::ResourceNotFound
- 405 - ActiveResource::MethodNotAllowed
- 409 - ActiveResource::ResourceConflict
- 410 - ActiveResource::ResourceGone
- 422 - ActiveResource::ResourceInvalid (rescued by save as validation errors)
- 401..499 - ActiveResource::ClientError
- 500..599 - ActiveResource::ServerError
- Other - ActiveResource::ConnectionError
These custom exceptions allow you to deal with resource errors more naturally and with more precision rather than returning a general HTTP error. For example:
begin
ryan = Person.find(my_id)
rescue ActiveResource::ResourceNotFound
redirect_to :action => 'not_found'
rescue ActiveResource::ResourceConflict, ActiveResource::ResourceInvalid
redirect_to :action => 'new'
end
Validation errors
Active Resource supports validations on resources and will return errors if any these validations fail (e.g., "First name can not be blank" and so on). These types of errors are denoted in the response by a response code of 422 and an XML or JSON representation of the validation errors. The save operation will then fail (with a false return value) and the validation errors can be accessed on the resource in question.
ryan = Person.find(1)
ryan.first # => ''
ryan.save # => false
# When
# PUT http://api.people.com:3000/people/1.xml
# or
# PUT http://api.people.com:3000/people/1.json
# is requested with invalid values, the response is:
#
# Response (422):
# <errors type="array"><error>First cannot be empty</error></errors>
# or
# {"errors":["First cannot be empty"]}
#
ryan.errors.invalid?(:first) # => true
ryan.errors.full_messages # => ['First cannot be empty']
Learn more about Active Resource‘s validation features in the ActiveResource::Validations documentation.
Timeouts
Active Resource relies on HTTP to access RESTful APIs and as such is inherently susceptible to slow or unresponsive servers. In such cases, your Active Resource method calls could \timeout. You can control the amount of time before Active Resource times out with the timeout variable.
class Person < ActiveResource::Base
self.site = "http://api.people.com:3000/"
self.timeout = 5
end
This sets the timeout to 5 seconds. You can adjust the timeout to a value suitable for the RESTful API you are accessing. It is recommended to set this to a reasonably low value to allow your Active Resource clients (especially if you are using Active Resource in a Rails application) to fail-fast (see en.wikipedia.org/wiki/Fail-fast) rather than cause cascading failures that could incapacitate your server.
When a \timeout occurs, an ActiveResource::TimeoutError is raised. You should rescue from ActiveResource::TimeoutError in your Active Resource method calls.
Internally, Active Resource relies on Ruby‘s Net::HTTP library to make HTTP requests. Setting timeout sets the read_timeout of the internal Net::HTTP instance to the same value. The default read_timeout is 60 seconds on most Ruby implementations.
- ==
- as_json
- clone
- collection_path
- collection_path
- connection
- connection
- create
- create
- delete
- destroy
- dup
- element_path
- element_path
- encode
- eql?
- exists?
- exists?
- find
- format
- format=
- hash
- headers
- id
- id=
- id_from_response
- load
- load_attributes_from_response
- new
- new?
- new_record?
- password
- password=
- prefix
- prefix=
- prefix_source
- proxy
- proxy=
- reload
- respond_to?
- save
- site
- site=
- ssl_options
- ssl_options=
- timeout
- timeout=
- to_param
- to_xml
- update
- user
- user=
Gets the collection path for the REST resources. If the query_options parameter is omitted, Rails will split from the prefix_options.
Options
- prefix_options - A hash to add a prefix to the request for nested URL‘s (e.g., :account_id => 19 would yield a URL like /accounts/19/purchases.xml).
- query_options - A hash to add items to the query string for the request.
Examples
Post.collection_path
# => /posts.xml
Comment.collection_path(:post_id => 5)
# => /posts/5/comments.xml
Comment.collection_path(:post_id => 5, :active => 1)
# => /posts/5/comments.xml?active=1
Comment.collection_path({:post_id => 5}, {:active => 1})
# => /posts/5/comments.xml?active=1
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 500
500: def collection_path(prefix_options = {}, query_options = nil)
501: prefix_options, query_options = split_options(prefix_options) if query_options.nil?
502: "#{prefix(prefix_options)}#{collection_name}.#{format.extension}#{query_string(query_options)}"
503: end
An instance of ActiveResource::Connection that is the base \connection to the remote service. The refresh parameter toggles whether or not the \connection is refreshed at every request or not (defaults to false).
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 385
385: def connection(refresh = false)
386: if defined?(@connection) || superclass == Object
387: @connection = Connection.new(site, format) if refresh || @connection.nil?
388: @connection.proxy = proxy if proxy
389: @connection.user = user if user
390: @connection.password = password if password
391: @connection.timeout = timeout if timeout
392: @connection.ssl_options = ssl_options if ssl_options
393: @connection
394: else
395: superclass.connection
396: end
397: end
Creates a new resource instance and makes a request to the remote service that it be saved, making it equivalent to the following simultaneous calls:
ryan = Person.new(:first => 'ryan') ryan.save
Returns the newly created resource. If a failure has occurred an exception will be raised (see save). If the resource is invalid and has not been saved then valid? will return false, while new? will still return true.
Examples
Person.create(:name => 'Jeremy', :email => 'myname@nospam.com', :enabled => true) my_person = Person.find(:first) my_person.email # => myname@nospam.com dhh = Person.create(:name => 'David', :email => 'dhh@nospam.com', :enabled => true) dhh.valid? # => true dhh.new? # => false # We'll assume that there's a validation that requires the name attribute that_guy = Person.create(:name => '', :email => 'thatguy@nospam.com', :enabled => true) that_guy.valid? # => false that_guy.new? # => true
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 531
531: def create(attributes = {})
532: self.new(attributes).tap { |resource| resource.save }
533: end
Deletes the resources with the ID in the id parameter.
Options
All options specify \prefix and query parameters.
Examples
Event.delete(2) # sends DELETE /events/2 Event.create(:name => 'Free Concert', :location => 'Community Center') my_event = Event.find(:first) # let's assume this is event with ID 7 Event.delete(my_event.id) # sends DELETE /events/7 # Let's assume a request to events/5/cancel.xml Event.delete(params[:id]) # sends DELETE /events/5
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 608
608: def delete(id, options = {})
609: connection.delete(element_path(id, options))
610: end
Gets the element path for the given ID in id. If the query_options parameter is omitted, Rails will split from the \prefix options.
Options
prefix_options - A \hash to add a \prefix to the request for nested URLs (e.g., :account_id => 19
would yield a URL like <tt>/accounts/19/purchases.xml</tt>).
query_options - A \hash to add items to the query string for the request.
Examples
Post.element_path(1)
# => /posts/1.xml
Comment.element_path(1, :post_id => 5)
# => /posts/5/comments/1.xml
Comment.element_path(1, :post_id => 5, :active => 1)
# => /posts/5/comments/1.xml?active=1
Comment.element_path(1, {:post_id => 5}, {:active => 1})
# => /posts/5/comments/1.xml?active=1
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 474
474: def element_path(id, prefix_options = {}, query_options = nil)
475: prefix_options, query_options = split_options(prefix_options) if query_options.nil?
476: "#{prefix(prefix_options)}#{collection_name}/#{id}.#{format.extension}#{query_string(query_options)}"
477: end
Asserts the existence of a resource, returning true if the resource is found.
Examples
Note.create(:title => 'Hello, world.', :body => 'Nothing more for now...') Note.exists?(1) # => true Note.exists(1349) # => false
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 619
619: def exists?(id, options = {})
620: if id
621: prefix_options, query_options = split_options(options[:params])
622: path = element_path(id, prefix_options, query_options)
623: response = connection.head(path, headers)
624: response.code.to_i == 200
625: end
626: # id && !find_single(id, options).nil?
627: rescue ActiveResource::ResourceNotFound, ActiveResource::ResourceGone
628: false
629: end
Core method for finding resources. Used similarly to Active Record‘s find method.
Arguments
The first argument is considered to be the scope of the query. That is, how many resources are returned from the request. It can be one of the following.
- :one - Returns a single resource.
- :first - Returns the first resource found.
- :last - Returns the last resource found.
- :all - Returns every resource that matches the request.
Options
- :from - Sets the path or custom method that resources will be fetched from.
- :params - Sets query and \prefix (nested URL) parameters.
Examples
Person.find(1)
# => GET /people/1.xml
Person.find(:all)
# => GET /people.xml
Person.find(:all, :params => { :title => "CEO" })
# => GET /people.xml?title=CEO
Person.find(:first, :from => :managers)
# => GET /people/managers.xml
Person.find(:last, :from => :managers)
# => GET /people/managers.xml
Person.find(:all, :from => "/companies/1/people.xml")
# => GET /companies/1/people.xml
Person.find(:one, :from => :leader)
# => GET /people/leader.xml
Person.find(:all, :from => :developers, :params => { :language => 'ruby' })
# => GET /people/developers.xml?language=ruby
Person.find(:one, :from => "/companies/1/manager.xml")
# => GET /companies/1/manager.xml
StreetAddress.find(1, :params => { :person_id => 1 })
# => GET /people/1/street_addresses/1.xml
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 581
581: def find(*arguments)
582: scope = arguments.slice!(0)
583: options = arguments.slice!(0) || {}
584:
585: case scope
586: when :all then find_every(options)
587: when :first then find_every(options).first
588: when :last then find_every(options).last
589: when :one then find_one(options)
590: else find_single(scope, options)
591: end
592: end
Returns the current format, default is ActiveResource::Formats::XmlFormat.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 338
338: def format
339: read_inheritable_attribute(:format) || ActiveResource::Formats[:xml]
340: end
Sets the format that attributes are sent and received in from a mime type reference:
Person.format = :json Person.find(1) # => GET /people/1.json Person.format = ActiveResource::Formats::XmlFormat Person.find(1) # => GET /people/1.xml
Default format is :xml.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 329
329: def format=(mime_type_reference_or_format)
330: format = mime_type_reference_or_format.is_a?(Symbol) ?
331: ActiveResource::Formats[mime_type_reference_or_format] : mime_type_reference_or_format
332:
333: write_inheritable_attribute(:format, format)
334: connection.format = format if site
335: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 399
399: def headers
400: @headers ||= {}
401: end
Constructor method for \new resources; the optional attributes parameter takes a \hash of attributes for the \new resource.
Examples
my_course = Course.new my_course.name = "Western Civilization" my_course.lecturer = "Don Trotter" my_course.save my_other_course = Course.new(:name => "Philosophy: Reason and Being", :lecturer => "Ralph Cling") my_other_course.save
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 724
724: def initialize(attributes = {})
725: @attributes = {}
726: @prefix_options = {}
727: load(attributes)
728: end
Gets the \password for REST HTTP authentication.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 305
305: def password
306: # Not using superclass_delegating_reader. See +site+ for explanation
307: if defined?(@password)
308: @password
309: elsif superclass != Object && superclass.password
310: superclass.password.dup.freeze
311: end
312: end
Sets the \password for REST HTTP authentication.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 315
315: def password=(password)
316: @connection = nil
317: @password = password
318: end
Gets the \prefix for a resource‘s nested URL (e.g., prefix/collectionname/1.xml) This method is regenerated at runtime based on what the \prefix is set to.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 412
412: def prefix(options={})
413: default = site.path
414: default << '/' unless default[-1..-1] == '/'
415: # generate the actual method based on the current site path
416: self.prefix = default
417: prefix(options)
418: end
Sets the \prefix for a resource‘s nested URL (e.g., prefix/collectionname/1.xml). Default value is site.path.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 429
429: def prefix=(value = '/')
430: # Replace :placeholders with '#{embedded options[:lookups]}'
431: prefix_call = value.gsub(/:\w+/) { |key| "\#{options[#{key}]}" }
432:
433: # Clear prefix parameters in case they have been cached
434: @prefix_parameters = nil
435:
436: # Redefine the new methods.
437: code, line = "def prefix_source() \"\#{value}\" end\ndef prefix(options={}) \"\#{prefix_call}\" end\n", __LINE__ + 1
438: silence_warnings { instance_eval code, __FILE__, line }
439: rescue
440: logger.error "Couldn't set prefix: #{$!}\n #{code}"
441: raise
442: end
An attribute reader for the source string for the resource path \prefix. This method is regenerated at runtime based on what the \prefix is set to.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 422
422: def prefix_source
423: prefix # generate #prefix and #prefix_source methods first
424: prefix_source
425: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 273
273: def proxy
274: # Not using superclass_delegating_reader. See +site+ for explanation
275: if defined?(@proxy)
276: @proxy
277: elsif superclass != Object && superclass.proxy
278: superclass.proxy.dup.freeze
279: end
280: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 283
283: def proxy=(proxy)
284: @connection = nil
285: @proxy = proxy.nil? ? nil : create_proxy_uri_from(proxy)
286: end
Gets the URI of the REST resources to map for this class. The site variable is required for Active Resource‘s mapping to work.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 236
236: def site
237: # Not using superclass_delegating_reader because don't want subclasses to modify superclass instance
238: #
239: # With superclass_delegating_reader
240: #
241: # Parent.site = 'http://anonymous@test.com'
242: # Subclass.site # => 'http://anonymous@test.com'
243: # Subclass.site.user = 'david'
244: # Parent.site # => 'http://david@test.com'
245: #
246: # Without superclass_delegating_reader (expected behaviour)
247: #
248: # Parent.site = 'http://anonymous@test.com'
249: # Subclass.site # => 'http://anonymous@test.com'
250: # Subclass.site.user = 'david' # => TypeError: can't modify frozen object
251: #
252: if defined?(@site)
253: @site
254: elsif superclass != Object && superclass.site
255: superclass.site.dup.freeze
256: end
257: end
Sets the URI of the REST resources to map for this class to the value in the site argument. The site variable is required for Active Resource‘s mapping to work.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 261
261: def site=(site)
262: @connection = nil
263: if site.nil?
264: @site = nil
265: else
266: @site = create_site_uri_from(site)
267: @user = URI.decode(@site.user) if @site.user
268: @password = URI.decode(@site.password) if @site.password
269: end
270: end
Returns the SSL options hash.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 374
374: def ssl_options
375: if defined?(@ssl_options)
376: @ssl_options
377: elsif superclass != Object && superclass.ssl_options
378: superclass.ssl_options
379: end
380: end
Options that will get applied to an SSL connection.
- :key - An OpenSSL::PKey::RSA or OpenSSL::PKey::DSA object.
- :cert - An OpenSSL::X509::Certificate object as client certificate
- :ca_file - Path to a CA certification file in PEM format. The file can contrain several CA certificates.
- :ca_path - Path of a CA certification directory containing certifications in PEM format.
- :verify_mode - Flags for server the certification verification at begining of SSL/TLS session. (OpenSSL::SSL::VERIFY_NONE or OpenSSL::SSL::VERIFY_PEER is acceptable)
- :verify_callback - The verify callback for the server certification verification.
- :verify_depth - The maximum depth for the certificate chain verification.
- :cert_store - OpenSSL::X509::Store to verify peer certificate.
- :ssl_timeout -The SSL timeout in seconds.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 368
368: def ssl_options=(opts={})
369: @connection = nil
370: @ssl_options = opts
371: end
Gets the number of seconds after which requests to the REST API should time out.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 349
349: def timeout
350: if defined?(@timeout)
351: @timeout
352: elsif superclass != Object && superclass.timeout
353: superclass.timeout
354: end
355: end
Sets the number of seconds after which requests to the REST API should time out.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 343
343: def timeout=(timeout)
344: @connection = nil
345: @timeout = timeout
346: end
Gets the \user for REST HTTP authentication.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 289
289: def user
290: # Not using superclass_delegating_reader. See +site+ for explanation
291: if defined?(@user)
292: @user
293: elsif superclass != Object && superclass.user
294: superclass.user.dup.freeze
295: end
296: end
Sets the \user for REST HTTP authentication.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 299
299: def user=(user)
300: @connection = nil
301: @user = user
302: end
Test for equality. Resource are equal if and only if other is the same object or is an instance of the same class, is not new?, and has the same id.
Examples
ryan = Person.create(:name => 'Ryan') jamie = Person.create(:name => 'Jamie') ryan == jamie # => false (Different name attribute and id) ryan_again = Person.new(:name => 'Ryan') ryan == ryan_again # => false (ryan_again is new?) ryans_clone = Person.create(:name => 'Ryan') ryan == ryans_clone # => false (Different id attributes) ryans_twin = Person.find(ryan.id) ryan == ryans_twin # => true
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 820
820: def ==(other)
821: other.equal?(self) || (other.instance_of?(self.class) && other.id == id && other.prefix_options == prefix_options)
822: end
Coerces to a hash for JSON encoding.
Options
The options are passed to the to_json method on each attribute, so the same options as the to_json methods in Active Support.
- :only - Only include the specified attribute or list of attributes in the serialized output. Attribute names must be specified as strings.
- :except - Do not include the specified attribute or list of attributes in the serialized output. Attribute names must be specified as strings.
Examples
person = Person.new(:first_name => "Jim", :last_name => "Smith")
person.to_json
# => {"first_name": "Jim", "last_name": "Smith"}
person.to_json(:only => ["first_name"])
# => {"first_name": "Jim"}
person.to_json(:except => ["first_name"])
# => {"last_name": "Smith"}
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 967
967: def as_json(options = nil)
968: attributes.as_json(options)
969: end
Returns a \clone of the resource that hasn‘t been assigned an id yet and is treated as a \new resource.
ryan = Person.find(1) not_ryan = ryan.clone not_ryan.new? # => true
Any active resource member attributes will NOT be cloned, though all other attributes are. This is to prevent the conflict between any prefix_options that refer to the original parent resource and the newly cloned parent resource that does not exist.
ryan = Person.find(1)
ryan.address = StreetAddress.find(1, :person_id => ryan.id)
ryan.hash = {:not => "an ARes instance"}
not_ryan = ryan.clone
not_ryan.new? # => true
not_ryan.address # => NoMethodError
not_ryan.hash # => {:not => "an ARes instance"}
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 750
750: def clone
751: # Clone all attributes except the pk and any nested ARes
752: cloned = attributes.reject {|k,v| k == self.class.primary_key || v.is_a?(ActiveResource::Base)}.inject({}) do |attrs, (k, v)|
753: attrs[k] = v.clone
754: attrs
755: end
756: # Form the new resource - bypass initialize of resource with 'new' as that will call 'load' which
757: # attempts to convert hashes into member objects and arrays into collections of objects. We want
758: # the raw objects to be cloned so we bypass load by directly setting the attributes hash.
759: resource = self.class.new({})
760: resource.prefix_options = self.prefix_options
761: resource.send :instance_variable_set, '@attributes', cloned
762: resource
763: end
Deletes the resource from the remote service.
Examples
my_id = 3 my_person = Person.find(my_id) my_person.destroy Person.find(my_id) # 404 (Resource Not Found) new_person = Person.create(:name => 'James') new_id = new_person.id # => 7 new_person.destroy Person.find(new_id) # 404 (Resource Not Found)
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 883
883: def destroy
884: connection.delete(element_path, self.class.headers)
885: end
Duplicate the current resource without saving it.
Examples
my_invoice = Invoice.create(:customer => 'That Company') next_invoice = my_invoice.dup next_invoice.new? # => true next_invoice.save next_invoice == my_invoice # => false (different id attributes) my_invoice.customer # => That Company next_invoice.customer # => That Company
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 847
847: def dup
848: self.class.new.tap do |resource|
849: resource.attributes = @attributes
850: resource.prefix_options = @prefix_options
851: end
852: end
Returns the serialized string representation of the resource in the configured serialization format specified in ActiveResource::Base.format. The options applicable depend on the configured encoding format.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 974
974: def encode(options={})
975: case self.class.format
976: when ActiveResource::Formats[:xml]
977: self.class.format.encode(attributes, {:root => self.class.element_name}.merge(options))
978: when ActiveResource::Formats::JsonFormat
979: if ActiveResource::Base.include_root_in_json
980: self.class.format.encode({self.class.element_name => attributes}, options)
981: else
982: self.class.format.encode(attributes, options)
983: end
984: else
985: self.class.format.encode(attributes, options)
986: end
987: end
Tests for equality (delegates to ==).
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 825
825: def eql?(other)
826: self == other
827: end
Evaluates to true if this resource is not new? and is found on the remote service. Using this method, you can check for resources that may have been deleted between the object‘s instantiation and actions on it.
Examples
Person.create(:name => 'Theodore Roosevelt') that_guy = Person.find(:first) that_guy.exists? # => true that_lady = Person.new(:name => 'Paul Bean') that_lady.exists? # => false guys_id = that_guy.id Person.delete(guys_id) that_guy.exists? # => false
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 903
903: def exists?
904: !new? && self.class.exists?(to_param, :params => prefix_options)
905: end
Delegates to id in order to allow two resources of the same type and \id to work with something like:
[Person.find(1), Person.find(2)] & [Person.find(1), Person.find(4)] # => [Person.find(1)]
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 831
831: def hash
832: id.hash
833: end
Gets the \id attribute of the resource.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 784
784: def id
785: attributes[self.class.primary_key]
786: end
Sets the \id attribute of the resource.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 789
789: def id=(id)
790: attributes[self.class.primary_key] = id
791: end
A method to manually load attributes from a \hash. Recursively loads collections of resources. This method is called in initialize and create when a \hash of attributes is provided.
Examples
my_attrs = {:name => 'J&J Textiles', :industry => 'Cloth and textiles'}
my_attrs = {:name => 'Marty', :colors => ["red", "green", "blue"]}
the_supplier = Supplier.find(:first)
the_supplier.name # => 'J&M Textiles'
the_supplier.load(my_attrs)
the_supplier.name('J&J Textiles')
# These two calls are the same as Supplier.new(my_attrs)
my_supplier = Supplier.new
my_supplier.load(my_attrs)
# These three calls are the same as Supplier.create(my_attrs)
your_supplier = Supplier.new
your_supplier.load(my_attrs)
your_supplier.save
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1025
1025: def load(attributes)
1026: raise ArgumentError, "expected an attributes Hash, got #{attributes.inspect}" unless attributes.is_a?(Hash)
1027: @prefix_options, attributes = split_options(attributes)
1028: attributes.each do |key, value|
1029: @attributes[key.to_s] =
1030: case value
1031: when Array
1032: resource = find_or_create_resource_for_collection(key)
1033: value.map do |attrs|
1034: if attrs.is_a?(String) || attrs.is_a?(Numeric)
1035: attrs.duplicable? ? attrs.dup : attrs
1036: else
1037: resource.new(attrs)
1038: end
1039: end
1040: when Hash
1041: resource = find_or_create_resource_for(key)
1042: resource.new(value)
1043: else
1044: value.dup rescue value
1045: end
1046: end
1047: self
1048: end
A method to determine if the resource a \new object (i.e., it has not been POSTed to the remote service yet).
Examples
not_new = Computer.create(:brand => 'Apple', :make => 'MacBook', :vendor => 'MacMall') not_new.new? # => false is_new = Computer.new(:brand => 'IBM', :make => 'Thinkpad', :vendor => 'IBM') is_new.new? # => true is_new.save is_new.new? # => false
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 778
778: def new?
779: id.nil?
780: end
Alias for new?
A method to \reload the attributes of this object from the remote web service.
Examples
my_branch = Branch.find(:first) my_branch.name # => "Wislon Raod" # Another client fixes the typo... my_branch.name # => "Wislon Raod" my_branch.reload my_branch.name # => "Wilson Road"
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1000
1000: def reload
1001: self.load(self.class.find(to_param, :params => @prefix_options).attributes)
1002: end
A method to determine if an object responds to a message (e.g., a method call). In Active Resource, a Person object with a name attribute can answer true to my_person.respond_to?(:name), my_person.respond_to?(:name=), and my_person.respond_to?(:name?).
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1056
1056: def respond_to?(method, include_priv = false)
1057: method_name = method.to_s
1058: if attributes.nil?
1059: return super
1060: elsif attributes.has_key?(method_name)
1061: return true
1062: elsif ['?','='].include?(method_name.last) && attributes.has_key?(method_name.first(-1))
1063: return true
1064: end
1065: # super must be called at the end of the method, because the inherited respond_to?
1066: # would return true for generated readers, even if the attribute wasn't present
1067: super
1068: end
A method to \save (POST) or \update (PUT) a resource. It delegates to create if a \new object, update if it is existing. If the response to the \save includes a body, it will be assumed that this body is XML for the final object as it looked after the \save (which would include attributes like created_at that weren‘t part of the original submit).
Examples
my_company = Company.new(:name => 'RoleModel Software', :owner => 'Ken Auer', :size => 2) my_company.new? # => true my_company.save # sends POST /companies/ (create) my_company.new? # => false my_company.size = 10 my_company.save # sends PUT /companies/1 (update)
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 867
867: def save
868: new? ? create : update
869: end
Allows Active Resource objects to be used as parameters in Action Pack URL generation.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 794
794: def to_param
795: id && id.to_s
796: end
Converts the resource to an XML string representation.
Options
The options parameter is handed off to the to_xml method on each attribute, so it has the same options as the to_xml methods in Active Support.
- :indent - Set the indent level for the XML output (default is +2+).
- :dasherize - Boolean option to determine whether or not element names should replace underscores with dashes. Default is true. The default can be set to false by setting the module attribute ActiveSupport.dasherize_xml = false in an initializer. Because save uses this method, and there are no options on save, then you will have to set the default if you don‘t want underscores in element names to become dashes when the resource is saved. This is important when integrating with non-Rails applications.
- :camelize - Boolean option to determine whether or not element names should be converted to camel case, e.g some_name to SomeName. Default is false. Like :dasherize you can change the default by setting the module attribute ActiveSupport.camelise_xml = true in an initializer.
- :skip_instruct - Toggle skipping the +instruct!+ call on the XML builder that generates the XML declaration (default is false).
Examples
my_group = SubsidiaryGroup.find(:first) my_group.to_xml # => <?xml version="1.0" encoding="UTF-8"?> # <subsidiary_group> [...] </subsidiary_group> my_group.to_xml(:dasherize => true) # => <?xml version="1.0" encoding="UTF-8"?> # <subsidiary-group> [...] </subsidiary-group> my_group.to_xml(:skip_instruct => true) # => <subsidiary_group> [...] </subsidiary_group>
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 939
939: def to_xml(options={})
940: attributes.to_xml({:root => self.class.element_name}.merge(options))
941: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1106
1106: def collection_path(options = nil)
1107: self.class.collection_path(options || prefix_options)
1108: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1072
1072: def connection(refresh = false)
1073: self.class.connection(refresh)
1074: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1084
1084: def create
1085: connection.post(collection_path, encode, self.class.headers).tap do |response|
1086: self.id = id_from_response(response)
1087: load_attributes_from_response(response)
1088: end
1089: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1102
1102: def element_path(options = nil)
1103: self.class.element_path(to_param, options || prefix_options)
1104: end
Takes a response from a typical create post and pulls the ID out
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1098
1098: def id_from_response(response)
1099: response['Location'][/\/([^\/]*?)(\.\w+)?$/, 1] if response['Location']
1100: end
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1091
1091: def load_attributes_from_response(response)
1092: if response['Content-Length'] != "0" && response.body.strip.size > 0
1093: load(self.class.format.decode(response.body))
1094: end
1095: end
Update the resource on the remote service.
[ show source ]
# File activeresource/lib/active_resource/base.rb, line 1077
1077: def update
1078: connection.put(element_path(prefix_options), encode, self.class.headers).tap do |response|
1079: load_attributes_from_response(response)
1080: end
1081: end